import 'package:dart_result/dart_result.dart';
import 'package:test/test.dart';

Result<int> truncDiv(int num1, int num2) {
  if (num2 == 0) {
    return Failure('cannot divide by zero');
  }
  return Success(num1 ~/ num2);
}

void main() {
  group('A group of tests', () {
    Result<int> testResult1;
    Result<int> testResult2;

    setUp(() {
      testResult1 = truncDiv(4, 5);
      testResult2 = truncDiv(12, 0);
    });

    test('Match Test', () {
      final value = testResult1.match((val) => val, (val) => val);
      expect(value, equals(0));
    });

    test('isFailure', () {
      expect(testResult2.isFailure, isTrue);
    });

    test('isSuccess', () {
      expect(testResult1.isSuccess, isTrue);
    });

    test('isSuccess == false when failure', () {
      expect(testResult2.isSuccess, isFalse);
    });

    test('isFailure == false when success', () {
      expect(testResult1.isFailure, isFalse);
    });
    test('getOrElse returns default', () {
      final failed = testResult2.getOrElse((val) => 0);
      expect(failed, equals(0));
    });
    test('getOrElse returns success', () {
      final result = truncDiv(5, 4);
      expect(result.getOrElse((val) => 0), 1);
    });
  });
}
